package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

import java.util.ArrayList;
import java.util.List;

public class DistributionCenter extends AbstractBehavior<DistributionCenter.Message> {

    public static class ArriveMessage implements Message {
        private final List<Paket> pakete;
        private final ActorRef<DeliveryCar.Message> truck;

        public ArriveMessage(List<Paket> pakete, ActorRef<DeliveryCar.Message> truck) {
            this.pakete = pakete;
            this.truck = truck;
        }

        public List<Paket> getPakete() {
            return pakete;
        }

        public ActorRef<DeliveryCar.Message> getTruck() {
            return truck;
        }
    }

    private DistributionCenter(ActorContext<Message> context) {
        super(context);
    }

    interface Message {}

    public static Behavior<Message> create() {
        return Behaviors.setup(DistributionCenter::new);
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(ArriveMessage.class, this::onArriveMessage)
                .build();
    }

    private Behavior<Message> onArriveMessage(ArriveMessage msg) {
        // Füge alle Pakete aus der Ankunftsnachricht dem Lagerraum hinzu
        List<Paket> pakete = msg.getPakete();
        getContext().getLog().info("Angekommene Pakete: {}", pakete);

        // Hier kann die weitere Logik für die Behandlung der Pakete implementiert werden

        // Beispiel: Senden der Pakete an einen internen Akteur zur weiteren Verarbeitung
        // ...

        return this;
    }
}
